rm(list = ls())
source("http://sablab.net/scripts/LibMA.r")
setwd("d:/data")

Tab = read.table("Summary_CountsHuman.txt",header=T,sep="\t",as.is=T)

str(Tab)

idx = Tab$Species.ID == 9606
sum(idx)
idx = idx & Tab$Total.num.conserved.sites > 0;
sum(idx)

Dat = data.frame(matrix(nr=sum(idx),nc=4))
Dat[,1] = Tab$Representative.miRNA[idx]
Dat[,2] = Tab$Transcript.ID[idx]
Dat[,3] = Tab$Gene.Symbol[idx]
Dat[,4] = as.double(Tab$Total.context.score)[idx]
names(Dat) = c("miRNA","RefSeq","GeneSymbol","Score" )
str(Dat)

plot(density(Dat$Score,na.rm=T) )

miR = as.character(Dat$miRNA)

miR = sub("hsa-miR-","",miR)
miR = sub("hsa-mir-","",miR)
miR = sub("hsa-let-","",miR)
miR = sub("-3p$","",miR)
miR = sub("-5p$","",miR)
miR.unique = unique(miR)
miR.unique = sort(miR.unique)

link = paste(miR,Tab$Transcript.ID[idx])

DS = SummarizeRows(cbind(Dat[,4],0),cbind(miR,Dat[,c(-1,-4)],link,stringsAsFactors=F),by.col=4)
str(DS)
Dat2 = data.frame(matrix(nr=DS$ng,nc=4))
Dat2[,1:3] = DS$Anno[,1:3]
Dat2[,4] = DS$Data[,1]
Dat2[is.na(Dat2[,4]),4] = 0
names(Dat2) = c("miRNA","RefSeq","GeneSymbol","Score" )
str(Dat2)

write.table(Dat2,"TargetScan4CoExpress.txt",row.names=F,sep="\t",quote = F)


